<template>
  <div class="col">
    <table-view
      :meta="meta"
      :items="data"
      :column="column"
      :checked-rows="checkedRows"
      @row-checked="onRowChecked"
      @all-row-checked="onAllRowsChecked"
      @row-clicked="onRowClick"
      @row-edit-clicked="onRowEditClick"
      @row-delete-clicked="onDeleteClicked"
      @page-option-changed="onPageOptionChanged"
      @sort-changed="onSortChanged"
      @filtering="onFiltering"
    />
  </div>
</template>

<script>
import { mapActions, mapState, mapGetters } from 'vuex'
import TableView from '@/components/table-view'
import { resource } from '@/mixins'
import { reducer, storage } from '@/utilities'

export default {
  name: 'resource-table',

  mixins: [resource],

  components: { TableView },

  watch: {
    $route (to) {
      this.init(to.query)
    }
  },

  computed: {
    ...mapState('resource', ['checkedRows']),

    ...mapGetters('resource', ['meta', 'data']),

    column () {
      if (this.meta.hasOwnProperty('column')) return this.meta.column

      const meta = storage.get(this.meta.resource)

      meta.column = reducer.column((this.meta.fields || []).slice())

      storage.set(meta.resource, meta)

      return meta.column
    }
  },

  methods: {
    ...mapActions('resource', ['fetch']),

    checkRow (item) {
      let rows = (this.checkedRows || []).slice()

      if (!rows.includes(item.id)) {
        rows.push(item.id)
      } else {
        rows = rows.filter(row => row !== item.id)
      }

      this.$store.commit('resource/rowsChecked', rows)
    },

    onRowChecked (item, event) {
      this.checkRow(item)
    },

    onAllRowsChecked (check) {
      this.$store.commit(
        'resource/rowsChecked',
        check ? (this.data || []).map(item => item.id) : []
      )
    },

    onRowClick (item) {
      this.checkRow(item)
    },

    onRowEditClick ({ id }) {
      this.$router.push({
        name: `${this.meta.resource}.edit`,
        params: { id }
      })
    },

    onPageOptionChanged (value) {
      this.$router.push({
        query: {
          page: 1,
          per_page: value
        }
      })
    },

    onSortChanged ({ currentPage, perPage, sortBy, sortDesc }) {
      const query = {
        page: currentPage,
        per_page: perPage
      }

      if (sortBy) {
        query.sort = { [sortBy]: sortDesc ? 'desc' : 'asc' }
      }

      this.$router.push({ query })
    },

    onFiltering (filter) {
      this.$router.push({
        query: { filter }
      })
    },

    async onDeleteClicked (item) {
      await this.deleteItem(item)

      this.init()
    },

    async init ({ page = 1, perPage = 15, ...params } = {}) {
      this.busy()

      await this.fetch({ page, perPage, ...params })

      this.done()
    }
  }
}
</script>
